<?php

Yii::import('application.modules.core_models.models._base.BasePasswordModel');

/**
 * This is the model base class for the table "account".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Account".
 *
 * Columns in table "account" available as properties of the model,
 * followed by relations of table "account" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property integer $country_id
 * @property integer $partner_site_id
 * @property integer $account_type_id
 * @property integer $location_id
 * @property integer $position_id
 * @property string $email
 * @property string $secret
 * @property string $first_name
 * @property string $last_name
 * @property integer $enabled
 * @property integer $is_beta_account
 * @property integer $only_dashboard
 * @property integer $premium_explored
 * @property integer $research_mode
 * @property string $research_date_populated
 * @property string $research_date_initialization
 * @property string $salesforce_lead_id
 * @property integer $has_review_kiosk_program
 * @property string $reward_order_id
 * @property string $date_reward_sent
 * @property string $date_signed_in
 * @property string $date_added
 * @property string $date_updated
 * @property string $last_password_change
 * @property string $organization_name
 * @property string $address
 * @property string $address_2
 * @property string $phone_number
 * @property string $fax_number
 * @property integer $contacted
 * @property integer $follow_up
 * @property string $email_cc
 * @property string $campaign
 * @property string $utm_variables
 * @property string $note
 *
 * @property Country $country
 * @property Localization $localization
 * @property Position $position
 * @property AccountType $accountType
 * @property Location $location
 * @property PartnerSite $partnerSite
 * @property AccountDetails[] $accountDetails
 * @property AccountDevice[] $accountDevices
 * @property AccountDeviceHistory[] $accountDeviceHistories
 * @property AccountEmr[] $accountEmrs
 * @property AccountLogin[] $accountLogins
 * @property AccountPractice[] $accountPractices
 * @property AccountProvider[] $accountProviders
 * @property Client[] $clients
 * @property DeviceHistory[] $deviceHistories
 * @property ManualValidation[] $manualValidations
 * @property OrganizationAccount[] $organizationAccounts
 * @property OrganizationHistory[] $organizationHistories
 * @property ProviderRatingWidget[] $providerRatingWidgets
 * @property ResearchLog[] $researchLogs
 * @property ResearchLog[] $researchLogs1
 * @property ReviewRequest[] $reviewRequests
 * @property VisitReason[] $visitReasons
 * @property Widget[] $widgets
 */
abstract class BaseAccount extends BasePasswordModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'account';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Account|Accounts', $n);
    }

    public static function representingColumn()
    {
        return 'email';
    }

    public function rules()
    {
        return array(
            array(
                'partner_site_id, account_type_id, location_id, position_id, email, first_name, last_name',
                'required'
            ),
            array(
                'localization_id, country_id, partner_site_id, account_type_id, location_id, position_id,
                is_beta_account, only_dashboard, enabled, premium_explored, research_mode, has_review_kiosk_program,
                contacted, follow_up',
                'numerical',
                'integerOnly' => true
            ),
            array('email', 'length', 'max' => 254),
            array('reward_order_id, campaign', 'length', 'max' => 32),
            array('secret', 'length', 'max' => 60),
            array('first_name', 'length', 'max' => 50),
            array('last_name, address, address_2', 'length', 'max' => 80),
            array('organization_name', 'length', 'max' => 100),
            array('salesforce_lead_id', 'length', 'max' => 18),
            array('phone_number, fax_number', 'length', 'max' => 14),
            array('email_cc', 'length', 'max' => 255),
            array('note, utm_variables', 'length', 'max' => 1024),
            array('research_date_initialization, research_date_populated, date_reward_sent, date_signed_in, date_added, date_updated, last_password_change', 'safe'),
            array('localization_id, country_id, is_beta_account, only_dashboard, enabled, premium_explored, research_mode, research_date_populated, research_date_initialization, salesforce_lead_id, has_review_kiosk_program, reward_order_id, date_reward_sent, date_signed_in, date_added, date_updated, organization_name, address, address_2, phone_number, fax_number, contacted, follow_up, email_cc, campaign, note, utm_variables', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, localization_id, country_id, partner_site_id, account_type_id, location_id, position_id, email, first_name, last_name, is_beta_account, enabled, premium_explored, research_mode, research_date_populated, research_date_initialization, salesforce_lead_id, has_review_kiosk_program, reward_order_id, date_reward_sent, date_signed_in, date_added, date_updated, last_password_change, organization_name, address, address_2, phone_number, fax_number, contacted, follow_up, email_cc, campaign, note, utm_variables', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'country' => array(self::BELONGS_TO, 'Country', 'country_id'),
            'localization' => array(self::BELONGS_TO, 'Localization', 'localization_id'),
            'position' => array(self::BELONGS_TO, 'Position', 'position_id'),
            'accountType' => array(self::BELONGS_TO, 'AccountType', 'account_type_id'),
            'location' => array(self::BELONGS_TO, 'Location', 'location_id'),
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'accountDetails' => array(self::HAS_MANY, 'AccountDetails', 'account_id'),
            'accountDevices' => array(self::HAS_MANY, 'AccountDevice', 'account_id'),
            'accountDeviceHistories' => array(self::HAS_MANY, 'AccountDeviceHistory', 'account_id'),
            'accountEmrs' => array(self::HAS_MANY, 'AccountEmr', 'account_id'),
            'accountLogins' => array(self::HAS_MANY, 'AccountLogin', 'account_id'),
            'accountPractices' => array(self::HAS_MANY, 'AccountPractice', 'account_id'),
            'accountProviders' => array(self::HAS_MANY, 'AccountProvider', 'account_id'),
            'clients' => array(self::HAS_MANY, 'Client', 'rep_account_id'),
            'deviceHistories' => array(self::HAS_MANY, 'DeviceHistory', 'account_id'),
            'manualValidations' => array(self::HAS_MANY, 'ManualValidation', 'account_id'),
            'organizationAccounts' => array(self::HAS_MANY, 'OrganizationAccount', 'account_id'),
            'organizationHistories' => array(self::HAS_MANY, 'OrganizationHistory', 'account_id'),
            'providerRatingWidgets' => array(self::HAS_MANY, 'ProviderRatingWidget', 'account_id'),
            'researchLogs' => array(self::HAS_MANY, 'ResearchLog', 'account_id'),
            'researchLogs1' => array(self::HAS_MANY, 'ResearchLog', 'user_account_id'),
            'reviewRequests' => array(self::HAS_MANY, 'ReviewRequest', 'account_id'),
            'visitReasons' => array(self::HAS_MANY, 'VisitReason', 'account_id'),
            'widgets' => array(self::HAS_MANY, 'Widget', 'account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'country_id' => null,
            'partner_site_id' => null,
            'account_type_id' => null,
            'location_id' => null,
            'position_id' => null,
            'email' => Yii::t('app', 'Email'),
            'secret' => 'Secret',
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'is_beta_account' => Yii::t('app', 'Is Beta Account'),
            'only_dashboard' => Yii::t('app', 'Only Dashboard'),
            'enabled' => Yii::t('app', 'Enabled'),
            'premium_explored' => Yii::t('app', 'Premium Explored'),
            'research_mode' => Yii::t('app', 'Research Mode'),
            'research_date_populated' => Yii::t('app', 'Research Date Populated'),
            'research_date_initialization' => Yii::t('app', 'Research Date Initialization'),
            'salesforce_lead_id' => Yii::t('app', 'Salesforce Lead'),
            'has_review_kiosk_program' => Yii::t('app', 'Has Review Kiosk Program'),
            'reward_order_id' => Yii::t('app', 'Reward Order'),
            'date_reward_sent' => Yii::t('app', 'Date Reward Sent'),
            'date_signed_in' => Yii::t('app', 'Date Signed In'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'last_password_change' => Yii::t('app', 'Last Password Change'),
            'organization_name' => Yii::t('app', 'Organization Name'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'fax_number' => Yii::t('app', 'Fax Number'),
            'contacted' => Yii::t('app', 'Contacted'),
            'follow_up' => Yii::t('app', 'Follow Up'),
            'email_cc' => Yii::t('app', 'Email Cc'),
            'campaign' => Yii::t('app', 'Campaign'),
            'utm_variables' => Yii::t('app', 'UTM-Variables'),
            'note' => Yii::t('app', 'Note'),
            'country' => null,
            'localization' => null,
            'position' => null,
            'accountType' => null,
            'location' => null,
            'partnerSite' => null,
            'accountDetails' => null,
            'accountDevices' => null,
            'accountDeviceHistories' => null,
            'accountEmrs' => null,
            'accountLogins' => null,
            'accountPractices' => null,
            'accountProviders' => null,
            'clients' => null,
            'deviceHistories' => null,
            'manualValidations' => null,
            'organizationAccounts' => null,
            'organizationHistories' => null,
            'providerRatingWidgets' => null,
            'researchLogs' => null,
            'researchLogs1' => null,
            'reviewRequests' => null,
            'visitReasons' => null,
            'widgets' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('country_id', $this->country_id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('account_type_id', $this->account_type_id);
        $criteria->compare('location_id', $this->location_id);
        $criteria->compare('position_id', $this->position_id);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('secret', $this->secret, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('is_beta_account', $this->is_beta_account);
        $criteria->compare('only_dashboard', $this->only_dashboard);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('premium_explored', $this->premium_explored);
        $criteria->compare('research_mode', $this->research_mode);
        $criteria->compare('research_date_populated', $this->research_date_populated);
        $criteria->compare('research_date_initialization', $this->research_date_initialization);
        $criteria->compare('salesforce_lead_id', $this->salesforce_lead_id, true);
        $criteria->compare('has_review_kiosk_program', $this->has_review_kiosk_program);
        $criteria->compare('reward_order_id', $this->reward_order_id, true);
        $criteria->compare('date_reward_sent', $this->date_reward_sent, true);
        $criteria->compare('date_signed_in', $this->date_signed_in, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('last_password_change', $this->last_password_change, true);
        $criteria->compare('organization_name', $this->organization_name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('fax_number', $this->fax_number, true);
        $criteria->compare('contacted', $this->contacted);
        $criteria->compare('follow_up', $this->follow_up);
        $criteria->compare('email_cc', $this->email_cc, true);
        $criteria->compare('campaign', $this->campaign, true);
        $criteria->compare('utm_variables', $this->utm_variables, true);
        $criteria->compare('note', $this->note, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
